#ifndef BMP_HPP
#define BMP_HPP

#include <vector>
#include <map>
#include <string>
#include <iostream>

class Bitmap
{
	enum FLIP {
		NORM, 
		HFLIP,
		VFLIP,
		HVFLIP,
	};
	struct sp_ {
		unsigned short sp[4][64];
		unsigned int crc[4];
	};

private:
	std::vector<char*> bmp;
	std::map<std::string, int> name;

	std::vector<sp_> spr;
	unsigned short* generate8x8(std::string filename, int x, int y);

public:
	bool isLoaded(std::string file) {
		std::map<std::string, int>::iterator it = name.find(file);
		if (it == name.end())
			return false;
		else
			return true;
	}
	bool load(std::string);
	int getIndex(std::string);
	int getWidth(std::string);
	int getHeight(std::string);

	bool isLoaded(const char* file) { return isLoaded(std::string(file)); }
	bool load(const char* file) { return load(std::string(file)); }
	int getIndex(const char* file) { return getIndex(std::string(file)); }
	int getWidth(const char* file) { return getWidth(std::string(file)); }
	int getHeight(const char* file) { return getHeight(std::string(file)); }

	int getIndexSize(void);
	unsigned short* getIndexedSprPointer(int index);
	int generate16x16(std::string filename, int x, int y, int *hv_);
};

#endif
